from multigrid_1d import *

def test_residual_1d():
    n = 10
    h = 1.0 / n
    x = arange(n+1) * h
    L = { -1: -1.0/h**2, 0: 2.0/h**2, 1: -1.0/h**2 }
    u = x
    f = 0*x
    r = residual_1d(u, L, f)
    print abs(r).max()
    u = x**2
    f = -2+0*x
    r = residual_1d(u, L, f)
    print abs(r).max()
    u = x*(1-x)
    f = 2+0*x
    r = residual_1d(u, L, f)
    print abs(r).max()

def test_smooth_1d():
    smooth = lex_gs_1d
    n = 10
    h = 1.0 / n
    x = arange(n+1) * h
    L = { -1: -1.0/h**2, 0: 2.0/h**2, 1: -1.0/h**2 }
    u = x
    f = 0*x
    r = residual_1d(u, L, f)
    unew = smooth(u, L, f)
    print u
    print unew
    print abs(r).max(), abs(u-unew).max()
    u = x**2
    f = -2+0*x
    r = residual_1d(u, L, f)
    unew = smooth(u, L, f)
    print abs(r).max(), abs(u-unew).max()
    u = x*(1-x)
    f = 2+0*x
    r = residual_1d(u, L, f)
    unew = smooth(u, L, f)
    print abs(r).max(), abs(u-unew).max()

def test_fwr_1d():
    n = 10
    h = 1.0 / n
    x = arange(n+1) * h
    r = 1+0*x
    f = fwr_1d(r)
    print f
    r = 1+x
    f = fwr_1d(r)
    print f
    
def test_li_1d():
    n = 10
    h = 1.0 / n
    x = arange(n+1) * h
    e = 1+0*x
    u = li_1d(e)
    print e
    print u
    e = 1+x
    u = li_1d(e)
    print e
    print u
    
