# multigrid method
# implemented using functions in module
# simple, not very extensible
# functional style
# functions don't change their input arguments

from numpy import *

def maxabs(x):
    return abs(x).max()

def convfact(x):
    x = asarray(x)
    return x[1:] / x[:-1]

def convrate(x):
    return -log10(convfact(x))

def weighted_relaxation(w, it):
    def newit(x, A, b):
        y = it(x, A, b)
        z = (1.0 - w) * x + w * y
        return z
    return newit

def mg(level, x, A, b, 
       smooth, residual, restrict, prolong, coarse_solve, cycle):
    if level == 0:
        x = coarse_solve(x, A[level], b)
    else:
        # generate new approximation x
    return x

def fmg(nlevels, x, A, b, mg, interpolate):
    x = mg(0, x, A[0], b[0])
    for level in range(1, nlevels):
        x = interpolate(x)
        x = mg(level, x, A[level], b[level])

def do_iteration(u, itfun, nit, tol, resfun, u_exact, norm):
    norm_res = []
    norm_err = []
    it = 0
    while 1:
        r = resfun(u)
        e = u - u_exact
        if 0:
            print r
            print u
            print u_exact
        norm_res.append(norm(r))
        norm_err.append(norm(e))
        if norm_res[-1] <= norm_res[0] * tol:
            break
        elif it < nit:
            u = itfun(u)
            it += 1
        else:
            break
    return norm_res, norm_err

def report_iteration(u, itfun, nit, tol, resfun, u_exact, norm):
    norm_res, norm_err = do_iteration(u, itfun, nit, tol, resfun, u_exact, norm)
    print "norm_res", norm_res
    print convfact(norm_res)
    print convrate(norm_res)
    print "norm_err", norm_err
    print convfact(norm_err)
    print convrate(norm_err)
